<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Asinhrono programiranje - obećanja</title>
  </head>
  <body>
    <h3>Promise i obrada izuzetaka u slucaju vise then metoda</h3>

    <script>
      const promise = new Promise(function (resolve, reject) {
        resolve(0);
      });

      // Ako funkcija ulancana metodom .then() vrati neku vrednost,
      // onda ce sam metod .then() vratiti obecanje na koje mozemo ulancati drugu funkciju.
      promise
        .then(function (value) {
          if (value > 0) {
            throw new Error("Vrednost je veca od 0");
          }
          document.body.appendChild(document.createTextNode(value + ","));
          return value + 1;
        })
        .then(function (value) {
          if (value > 0) {
            throw new Error("Vrednost je veca od 0");
          }
          document.body.appendChild(document.createTextNode(value + ","));
          return value + 1;
        })
        .then(function (value) {
          if (value > 0) {
            throw new Error("Vrednost je veca od 0");
          }
          document.body.appendChild(document.createTextNode(value + ","));
        })
        .catch(function (reason) {
          document.body.appendChild(
            document.createTextNode("--> catch: " + reason)
          );
        });
    </script>
  </body>
</html>
